'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactTestRenderer = require('react-test-renderer');

var _reactTestRenderer2 = _interopRequireDefault(_reactTestRenderer);

var _chai = require('chai');

var _createBehaviorSubject = require('observable-utils/lib/createBehaviorSubject');

var _createBehaviorSubject2 = _interopRequireDefault(_createBehaviorSubject);

var _withPropsFromObservables = require('../withPropsFromObservables');

var _withPropsFromObservables2 = _interopRequireDefault(_withPropsFromObservables);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('withPropsFromObservables', function () {
  return it('should work', function () {
    const subj$ = (0, _createBehaviorSubject2.default)();
    subj$.next(1);

    const Comp = (0, _withPropsFromObservables2.default)(function () {
      return {
        observed: subj$
      };
    })(function (props) {
      return _react2.default.createElement(
        'div',
        null,
        props.observed
      );
    });

    const rendered = _reactTestRenderer2.default.create(_react2.default.createElement(Comp, null));
    (0, _chai.expect)(rendered.toJSON().children[0]).to.equal(1);
    console.log(rendered.toJSON());

    subj$.next(2);
    (0, _chai.expect)(rendered.toJSON().children[0]).to.equal(2);
    return console.log(rendered.toJSON());
  });
});