'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const { assign } = Object; // An improved version of recompose withHandlers.
// The handlers are never regenerated; instead, they receive the latest
// props as an arg when they are invoked.

exports.default = function withConstHandlers(handlers) {
  return function (NextComponent) {
    let withConstHandlers = class withConstHandlers extends _react2.default.Component {
      constructor(props) {
        super(props);
        this.handlers = (() => {
          const _obj = {};for (let _i = 0, _keys = Object.keys(handlers), _len = _keys.length; _i < _len; _i++) {
            const k = _keys[_i];const f = handlers[k];_obj[k] = (...args) => f(this.props, ...args);
          }
          return _obj;
        })();
      }render() {
        return _react2.default.createElement(NextComponent, assign({}, this.props, this.handlers));
      }
    };
    return withConstHandlers;
  };
};