'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function unsubscribeFrom(k, subMap, subMapEntry) {
  subMapEntry[1].unsubscribe();
  return delete subMap[k];
} // Higher-order component that weaves in the current value of a collection of
// TC39 Observables into the props of the target component.
function subscribeTo(k, subMap, observable, component) {
  if (!observable) return;
  const subscription = observable.subscribe({
    next: function (value) {
      return component.setState({ [k]: value });
    } });
  return subMap[k] = [observable, subscription];
}function truthyFunction() {
  return true;
}
exports.default = function withPropsFromObservables(mapOfProps, shouldUpdate = truthyFunction) {
  return function (NextComponent) {
    let withPropsFromObservables = class withPropsFromObservables extends _react2.default.Component {
      constructor(props) {
        super(props);
        this.state = {};
        this._subscriptionMap = {};
      }updateFromProps(props) {
        const observableMap = mapOfProps(props);
        const subscriptionMap = this._subscriptionMap;

        // For each observable in the new map...
        for (let _i = 0, _keys = Object.keys(observableMap), _len = _keys.length; _i < _len; _i++) {
          const k = _keys[_i];const observable = observableMap[k];
          const currentSub = subscriptionMap[k];
          // If we are currently subscribed to the key...
          if (currentSub) {
            // If the key is not mapped to the correct observable right now, unsubscribe
            if (currentSub[0] !== observable) {
              unsubscribeFrom(k, subscriptionMap, currentSub);
              subscribeTo(k, subscriptionMap, observable, this);
            }
          } // If mapped to the correct observable, do nothing.
          else {
              // We aren't subscribed to the key at all.
              subscribeTo(k, subscriptionMap, observable, this);
            }
        } // For each subscription...
        for (let _i2 = 0, _keys2 = Object.keys(subscriptionMap), _len2 = _keys2.length; _i2 < _len2; _i2++) {
          const k = _keys2[_i2];const currentSub = subscriptionMap[k];
          // If not in the observableMap...
          if (!(k in observableMap)) {
            // Unsubscribe.
            unsubscribeFrom(k, subscriptionMap, currentSub);
          }
        }
      }unsubscribeAll() {
        for (let _obj = this._subscriptionMap, _i3 = 0, _keys3 = Object.keys(_obj), _len3 = _keys3.length; _i3 < _len3; _i3++) {
          const k = _keys3[_i3];const currentSub = _obj[k];
          unsubscribeFrom(k, this._subscriptionMap, currentSub);
        }
      }componentWillMount() {
        return this.updateFromProps(this.props);
      }componentWillReceiveProps(nextProps) {
        if (shouldUpdate(nextProps, this.props)) return this.updateFromProps(nextProps);
      }componentWillUnmount() {
        return this.unsubscribeAll();
      }render() {
        const passedProps = Object.assign({}, this.props, this.state);
        return _react2.default.createElement(NextComponent, passedProps);
      }
    };
    return withPropsFromObservables;
  };
};